#include "esp_camera.h"
#include <Arduino.h>
#include <WiFi.h>
#include <AsyncTCP.h>
#include <ESPAsyncWebServer.h>
#include <iostream>
#include <sstream>
#include "DFRobot_AXP313A.h"
#include "Arduino.h"
#include "FS.h"                
#include "SD_MMC.h"            
#include "soc/soc.h"           
#include "soc/rtc_cntl_reg.h"  
#include "driver/rtc_io.h"
#include <EEPROM.h>  
#include "SD.h"
#include "SPI.h"
#define EEPROM_SIZE 1   
int pictureNumber = 0;  
unsigned long times = 0;
unsigned long timess = 0;
DFRobot_AXP313A axp;
int tursd = 0;
#include "DFRobot_GDL.h"
#define TFT_DC D2
#define TFT_CS D6
#define TFT_RST D3
#define TFT_BL D13
DFRobot_ST7789_240x240_HW_SPI screen(/*dc=*/TFT_DC, /*cs=*/TFT_CS, /*rst=*/TFT_RST);


#include "DFRobot_EnvironmentalSensor.h"
#if defined(ARDUINO_AVR_UNO) || defined(ESP8266)
#include <SoftwareSerial.h>
#endif

#define MODESWITCH /*UART:*/ 1 /*I2C: 0*/

#if MODESWITCH
#if defined(ARDUINO_AVR_UNO) || defined(ESP8266)
SoftwareSerial mySerial(/*rx =*/4, /*tx =*/5);
DFRobot_EnvironmentalSensor environment(/*addr =*/SEN050X_DEFAULT_DEVICE_ADDRESS, /*s =*/&mySerial);  //创建一个广播地址的对象，可批量配置总线上的所有设备
#else
DFRobot_EnvironmentalSensor environment(/*addr =*/SEN050X_DEFAULT_DEVICE_ADDRESS, /*s =*/&Serial1);  //创建一个广播地址的对象，可批量配置总线上的所有设备
#endif
#else
DFRobot_EnvironmentalSensor environment(/*addr = */ SEN050X_DEFAULT_DEVICE_ADDRESS, /*pWire = */ &Wire);
#endif


#define FORWARD 1
#define BACKWARD -1

#define PWDN_GPIO_NUM -1
#define RESET_GPIO_NUM -1
#define XCLK_GPIO_NUM 45
#define SIOD_GPIO_NUM 1
#define SIOC_GPIO_NUM 2

#define Y9_GPIO_NUM 48
#define Y8_GPIO_NUM 46
#define Y7_GPIO_NUM 8
#define Y6_GPIO_NUM 7
#define Y5_GPIO_NUM 4
#define Y4_GPIO_NUM 41
#define Y3_GPIO_NUM 40
#define Y2_GPIO_NUM 39
#define VSYNC_GPIO_NUM 6
#define HREF_GPIO_NUM 42
#define PCLK_GPIO_NUM 5

const char *ssid = "ESP32 S3 Romeo";
const char *password = "12345678";

AsyncWebServer server(80);
AsyncWebSocket wsCamera("/Camera");
//AsyncWebSocket wsCarInput("/CarInput");
uint32_t cameraClientId = 0;

uint8_t Speed = 50;

const char *htmlHomePage PROGMEM = R"HTMLHOMEPAGE(
<!DOCTYPE html>
<html>
  <head>
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">
    <meta charset="utf-8">
  </head>
  <body class="noselect" align="center" style="background-color:white">
    <table id="mainTable" style="width:400px;margin:auto;table-layout:fixed" CELLSPACING=10>
      <tr>
        <img id="cameraImage" src="" style="width:400px;height:250px"></td>
      </tr>      
<tr>
     <div id="dht">
     </div>
 </tr> 
    </table>
    <script>
      var webSocketCameraUrl = "ws:\/\/" + window.location.hostname + "/Camera";
      var websocketCamera;
      function initCameraWebSocket() 
      {
        websocketCamera = new WebSocket(webSocketCameraUrl);
        websocketCamera.binaryType = 'blob';
        websocketCamera.onopen    = function(event){};
        websocketCamera.onclose   = function(event){setTimeout(initCameraWebSocket, 2000);};
        websocketCamera.onmessage = function(event)
        {
          var imageId = document.getElementById("cameraImage");
          imageId.src = URL.createObjectURL(event.data);
        };
      }
      function initWebSocket() 
      {
        initCameraWebSocket ();       
      }

      function sendButtonInput(key, value) 
      {
        var data = key + "," + value;     
      }

      window.onload = initWebSocket;
      document.getElementById("mainTable").addEventListener("touchend", function(event){
        event.preventDefault()
      });      
     setInterval(function () {
        var xhttp = new XMLHttpRequest();
        xhttp.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {             
                document.getElementById("dht").innerHTML = this.responseText;
            }
        };
        xhttp.open("GET", "/dht", true);
        xhttp.send();
    }, 1000)
    </script>
  </body>    
</html>
)HTMLHOMEPAGE";


String Merge_Data(void) {
  String dataBuffer = "<p>";
  dataBuffer += "<h1>Environmental data </h1>";
  dataBuffer += "<b>Temp: </b>";
  dataBuffer += String(environment.getTemperature(TEMP_C));
  dataBuffer += "<b>   ℃</b>";
  dataBuffer += "<br/>";
  dataBuffer += "<b>RH: </b>";
  dataBuffer += String(environment.getHumidity());
  dataBuffer += "<b>   %</b>";
  dataBuffer += "<br/>";
  dataBuffer += "<b>GSWP: </b>";
  dataBuffer += String(tursd);
  dataBuffer += "<b>   %</b>";
  dataBuffer += "<br/>";
  dataBuffer += "<b>LUX: </b>";
  dataBuffer += String(environment.getLuminousIntensity());
  dataBuffer += "<b>   lx</b>";
  dataBuffer += "<br/>";
  dataBuffer += "<b>UV: </b>";
  dataBuffer += String(environment.getUltravioletIntensity());
  dataBuffer += "<b>   mw/cm2</b>";
  dataBuffer += "<br /></p>";
  return dataBuffer;
}


void handleRoot(AsyncWebServerRequest *request) {
  request->send_P(200, "text/html", htmlHomePage);
}

void handleNotFound(AsyncWebServerRequest *request) {
  request->send(404, "text/plain", "File Not Found");
}


void onCameraWebSocketEvent(AsyncWebSocket *server,  
                            AsyncWebSocketClient *client,
                            AwsEventType type,
                            void *arg,
                            uint8_t *data,
                            size_t len) {
  switch (type) {
    case WS_EVT_CONNECT:
      Serial.printf("WebSocket client #%u connected from %s\n", client->id(), client->remoteIP().toString().c_str());
      cameraClientId = client->id();
      break;

    case WS_EVT_DISCONNECT:
      Serial.printf("WebSocket client #%u disconnected\n", client->id());
      cameraClientId = 0;
      break;
    case WS_EVT_DATA:
      break;
    case WS_EVT_PONG:
    case WS_EVT_ERROR:
      break;
    default:
      break;
  }
}

void setupCamera() {
  camera_config_t config;
  config.ledc_channel = LEDC_CHANNEL_0;
  config.ledc_timer = LEDC_TIMER_0;
  config.pin_d0 = Y2_GPIO_NUM;
  config.pin_d1 = Y3_GPIO_NUM;
  config.pin_d2 = Y4_GPIO_NUM;
  config.pin_d3 = Y5_GPIO_NUM;
  config.pin_d4 = Y6_GPIO_NUM;
  config.pin_d5 = Y7_GPIO_NUM;
  config.pin_d6 = Y8_GPIO_NUM;
  config.pin_d7 = Y9_GPIO_NUM;
  config.pin_xclk = XCLK_GPIO_NUM;
  config.pin_pclk = PCLK_GPIO_NUM;
  config.pin_vsync = VSYNC_GPIO_NUM;
  config.pin_href = HREF_GPIO_NUM;
  config.pin_sscb_sda = SIOD_GPIO_NUM;
  config.pin_sscb_scl = SIOC_GPIO_NUM;
  config.pin_pwdn = PWDN_GPIO_NUM;
  config.pin_reset = RESET_GPIO_NUM;
  config.xclk_freq_hz = 40000000;
  config.frame_size = FRAMESIZE_UXGA;
  config.pixel_format = PIXFORMAT_JPEG;
  config.grab_mode = CAMERA_GRAB_WHEN_EMPTY;
  config.fb_location = CAMERA_FB_IN_PSRAM;
  config.jpeg_quality = 12;
  config.fb_count = 1;

  if (config.pixel_format == PIXFORMAT_JPEG) {
    if (psramFound()) {
      config.jpeg_quality = 10;
      config.fb_count = 2;
      config.grab_mode = CAMERA_GRAB_LATEST;
    } else {
      config.frame_size = FRAMESIZE_SVGA;
      config.fb_location = CAMERA_FB_IN_DRAM;
    }
  } else {
    config.frame_size = FRAMESIZE_240X240;
#if CONFIG_IDF_TARGET_ESP32S3
    config.fb_count = 2;
#endif
  }
  esp_err_t err = esp_camera_init(&config);
  if (err != ESP_OK) {
    Serial.printf("Camera init failed with error 0x%x", err);
    return;
  }
  if (psramFound()) {
    heap_caps_malloc_extmem_enable(20000);
    Serial.printf("PSRAM initialized. malloc to take memory from psram above this size");
  }
}

void sendCameraPicture() {  
  if (cameraClientId == 0) {
    return;
  }
  unsigned long startTime1 = millis();
  camera_fb_t *fb = esp_camera_fb_get();
  if (!fb) {
    Serial.println("Frame buffer could not be acquired");
    return;
  }
  unsigned long startTime2 = millis();
  wsCamera.binary(cameraClientId, fb->buf, fb->len);
  esp_camera_fb_return(fb);
  while (true) {
    AsyncWebSocketClient *clientPointer = wsCamera.client(cameraClientId);
    if (!clientPointer || !(clientPointer->queueIsFull())) {
      break;
    }
    delay(1);
  }
  unsigned long startTime3 = millis();
  Serial.printf("last_button_time taken Total: %d|%d|%d\n", startTime3 - startTime1, startTime2 - startTime1, startTime3 - startTime2);
}

void SDinitialization() {  
  if (!SD.begin(9)) {
    Serial.println("Card Mount Failed");
    return;
  }
  uint8_t cardType = SD.cardType();
  if (cardType == CARD_NONE) {
    Serial.println("No SD card attached");
    return;
  }
  Serial.print("SD Card Type: ");
  if (cardType == CARD_MMC) {
    Serial.println("MMC");
  } else if (cardType == CARD_SD) {
    Serial.println("SDSC");
  } else if (cardType == CARD_SDHC) {
    Serial.println("SDHC");
  } else {
    Serial.println("UNKNOWN");
  }
  uint64_t cardSize = SD.cardSize() / (1024 * 1024);
  Serial.printf("SD Card Size: %lluMB\n", cardSize);
}

void setup(void) {
#if MODESWITCH
#if defined(ARDUINO_AVR_UNO) || defined(ESP8266)
  mySerial.begin(9600);
#elif defined(ESP32)
  Serial1.begin(9600, SERIAL_8N1, /*rx =*/D10, /*tx =*/D11);
#else
  Serial1.begin(9600);
#endif
#endif
  Serial.begin(115200);
  while (environment.begin() != 0) {
    Serial.println(" Sensor initialize failed!!");
    delay(1000);
  }
  Serial.println(" Sensor  initialize success!!");
  while (axp.begin() != 0) {
    Serial.println("init error");
    delay(1000);
  }
  axp.enableCameraPower(axp.eOV2640);  
  WiFi.softAP(ssid, password);
  IPAddress IP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(IP);
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request) {
    request->send_P(200, "text/html", htmlHomePage PROGMEM);
  });
  server.on("/dht", HTTP_GET, [](AsyncWebServerRequest *request) {
    request->send_P(200, "text/plain", Merge_Data().c_str());
  });
  server.on("/", HTTP_GET, handleRoot);
  server.onNotFound(handleNotFound);
  server.addHandler(&wsCamera);
  server.begin();
  Serial.println("HTTP server started");
  setupCamera();
  screen.begin();
  SDinitialization();  
}



void Imagestorage() {
  camera_fb_t *fb = NULL;  
  fb = esp_camera_fb_get();
  if (!fb) {
    Serial.println("Camera capture failed");
    return;
  }
  EEPROM.begin(EEPROM_SIZE);       
  pictureNumber = EEPROM.read(0) + 1;
  String path = "/picture" + String(pictureNumber) + ".jpg";  
  fs::FS &fs = SD;                                            
  Serial.printf("Picture file name: %s\n", path.c_str());
  File file = fs.open(path.c_str(), FILE_WRITE);
  if (!file) {
    Serial.println("Failed to open file in writing mode");
  } else {
    file.write(fb->buf, fb->len);  
    Serial.printf("Saved file to path: %s\n", path.c_str());
    EEPROM.write(0, pictureNumber);  
    EEPROM.commit();
  }
  file.close();
  esp_camera_fb_return(fb);
}


void xianshi() {
  int16_t color = 0x00FF;
  screen.setTextWrap(false);          
  screen.fillScreen(COLOR_RGB565_BLACK); 
  screen.setTextColor(color += 0x3000);   
  screen.setTextSize(2);                
  
  screen.setCursor(0, 0);
  screen.println("Temp:");
  screen.setCursor(60, 0);
  screen.println(environment.getTemperature(TEMP_C));

  screen.setCursor(0, 30);
  screen.println("RH:");
  screen.setCursor(40, 30);
  screen.println(environment.getHumidity());

  screen.setCursor(0, 60);
  screen.println("GSWP:");
  screen.setCursor(67, 60);
  screen.println(tursd);

  screen.setCursor(0, 90);
  screen.println("LUX:");
  screen.setCursor(50, 90);
  screen.println(environment.getLuminousIntensity());

  screen.setCursor(0, 120);
  screen.println("UV:");
  screen.setCursor(40, 120);
  screen.println(environment.getUltravioletIntensity());

  screen.setCursor(0, 150);
  screen.println("Image:");
  screen.setCursor(80, 150);
  screen.println(pictureNumber);
  delay(1000);
}



void loop() {
  wsCamera.onEvent(onCameraWebSocketEvent);
  if (cameraClientId == 0) {
      tursd = analogRead(A5);
    xianshi();
    times = millis();
    if (times - timess > 10000) {
      timess = times;
      Imagestorage();
    }
  } else {
    sendCameraPicture();
  }
  wsCamera.cleanupClients();
}
